// code by jph

#ifndef FORMAT_INCLUDED
#define FORMAT_INCLUDED

class format {
  public:
  static void bmp(char* name,const tensor<unsigned char>& img); // stores img in 24-bit/pixel bmp-file
};

void format::bmp(char* name,const tensor<unsigned char>& img) {
  assert(2<img.size[0]);
  FILE *fid=fopen(name,"wb");
  int num,sze,ofs=0x36;
  int mod=img.size[1]*3%4; // bgr.
  if (fid) {
    num=0x4d42; fwrite(&num,2,1,fid); // identifier
    sze=ofs+img.size[2]*(img.size[1]*3+(4-mod)*!!mod); // total file size
                fwrite(&sze,4,1,fid); // size of file (!)
    num=0;      fwrite(&num,4,1,fid); // unused
                fwrite(&ofs,4,1,fid); // pixel offset
    num=0x28;   fwrite(&num,4,1,fid); // size of header
                fwrite(&img.size[1],4,1,fid); // width
                fwrite(&img.size[2],4,1,fid); // height
    num=1;      fwrite(&num,2,1,fid); // color planes
    num=24;     fwrite(&num,2,1,fid); // bits per pixel, 3bytes
    num=0;      fwrite(&num,4,1,fid); // no compression
                fwrite(&img.numel,4,1,fid); // size of data
    num=0xc40e; fwrite(&num,4,1,fid); // pixel per meter resolution horizontal
    num=0xc40e; fwrite(&num,4,1,fid); // pixel per meter resolution vertical
    num=0;      fwrite(&num,4,1,fid); // colors in palette
                fwrite(&num,4,1,fid); // colors important
    for (int c0=0;c0<img.size[2];++c0) {
      for (int c1=0;c1<img.size[1];++c1) {
                fwrite(&img.data[num+2],1,1,fid); // b
                fwrite(&img.data[num+1],1,1,fid); // g
                fwrite(&img.data[num+0],1,1,fid); // r
        num+=img.size[0];
      }
      if (mod)
                fwrite(&num,4-mod,1,fid);
    }
    fclose(fid);
    printf("%s <- [%dx%d] = %d B\n",name,img.size[1],img.size[2],sze);
  } else {
    printf("%s <- (error)\n",name);
  }
}

#endif
